/**
 * @file          /kylin-license/lib/base/crypto-helper.h
 * @brief         
 * @author        tangjie02 <tangjie02@kylinos.com.cn>
 * @copyright (c) 2020 KylinSec. All rights reserved. 
 */
#pragma once

#include <giomm.h>
#include <openssl/evp.h>
#include <openssl/opensslv.h>

namespace Kiran
{
class CryptoHelper
{
public:
    CryptoHelper(){};
    virtual ~CryptoHelper() {}

    static std::string base64_decode(const std::string &source);
    static std::string base64_encode(const std::string &source);

    static bool des_encrypt(const std::string &message, std::string &encrypted_message, const std::string &key);
    static bool des_decrypt(const std::string &message, std::string &decrypted_message, const std::string &key);

private:
    static int base64_get_index(const char c);
};

}  // namespace Kiran
