/**
 * @file          /kylin-license/lib/base/file-utils.h
 * @brief         
 * @author        tangjie02 <tangjie02@kylinos.com.cn>
 * @copyright (c) 2020 KylinSec. All rights reserved. 
 */

#include <giomm.h>

#define LICENSE_NEW_INTERFACE
#include "license_i.h"

namespace Kiran
{
typedef sigc::slot<void, const Glib::RefPtr<Gio::File> &, const Glib::RefPtr<Gio::File> &, Gio::FileMonitorEvent> FileMonitorCallBack;

class FileUtils
{
public:
    FileUtils(){};
    virtual ~FileUtils(){};

    static Glib::RefPtr<Gio::FileMonitor> make_monitor_file(const std::string &path,
                                                            const FileMonitorCallBack &callback,
                                                            Gio::FileMonitorFlags flags = Gio::FILE_MONITOR_NONE);

    static std::string read_bdata(const std::string &file_path);

    static bool write_bdata(const std::string &file_path,
                            const std::string &data,
                            int oflag,
                            int mode_flag = 0);

    static int get_file_size(int fd);
};
}  // namespace Kiran
