/**
 * @file          /kylin-license/lib/base/time-utils.h
 * @brief         
 * @author        tangjie02 <tangjie02@kylinos.com.cn>
 * @copyright (c) 2020 KylinSec. All rights reserved. 
 */

#include <giomm.h>

#define LICENSE_NEW_INTERFACE
#include "license_i.h"

namespace Kiran
{
class TimeUtils
{
public:
    TimeUtils(){};
    virtual ~TimeUtils(){};

    // 获取当前日期
    static GDate get_current_gdate();

    // 日期转化为时间戳
    static time_t gdate2timestamp(const GDate *date);
    static time_t str2timestamp(const char *str);

    // 时间戳转化为日期
    static GDate timestamp2gdate(time_t t);

    // 格式化日期
    static std::string timestamp2str(time_t t);
    static std::string gdate2str(const GDate *date);
    static char *gdatetime2str(GDateTime *datetime);
    static std::string tm2str(const struct tm *tm_time);

    // 日期数组和GDate转换
    static bool arr2gdate(const unsigned char dt[], GDate *g_date);
    static LicenseErrorCode gdate2arr(const GDate *gd, unsigned char *ld);
};
}  // namespace Kiran