/**
 * @file          /kylin-license/src/sn/license-generator.cpp
 * @brief         
 * @author        tangjie02 <tangjie02@kylinos.com.cn>
 * @copyright (c) 2020 KylinSec. All rights reserved. 
 */

#pragma once

#include "lib/base/base.h"
#include "license_helper_dbus_proxy.h"

namespace Kiran
{
namespace DBus
{
class LicenseHelperProxyWrapper : public com::kylinsec::Kiran::LicenseHelper_proxy,
                                  public ::DBus::IntrospectableProxy,
                                  public ::DBus::ObjectProxy
{
public:
    static std::shared_ptr<LicenseHelperProxyWrapper> create(::DBus::Connection &connection, const std::string &path, const std::string &service_name);

    LicenseHelperProxyWrapper(::DBus::Connection &connection, const std::string &path, const std::string &service_name);
    virtual ~LicenseHelperProxyWrapper(){};

    sigc::signal<void, bool> signal_license_changed() { return this->license_changed_; };

protected:
    virtual void LicenseChanged(const bool &status_changed) { this->license_changed_.emit(status_changed); };

private:
    sigc::signal<void, bool> license_changed_;
};
}  // namespace DBus

}  // namespace Kiran
