/**
 * @file          /kylin-license/lib/ukey/ukey-virtual-device.h
 * @brief         
 * @author        tangjie02 <tangjie02@kylinos.com.cn>
 * @copyright (c) 2020 KylinSec. All rights reserved. 
 */
#pragma once

#include "lib/dbus/license_manager_proxy_wrapper.h"
#include "lib/dbus/license_object_proxy_wrapper.h"
#include "lib/ukey/ukey-database.h"
#include "lib/ukey/ukey-device.h"

namespace Kiran
{
class UKeyVirtualDevice : public UKeyDevice
{
public:
    UKeyVirtualDevice(std::shared_ptr<DBUKeyItem> ukey);
    virtual ~UKeyVirtualDevice(){};

    bool init();

    virtual UKeyPresenceType get_presence_type() { return UKeyPresenceType::UKEY_PRESENCE_TYPE_VIRTUAL; };

    // 通过机器码生成授权码
    virtual LicenseErrorCode generate_license_code(const std::string &machine_code,
                                                   const std::string &key,
                                                   std::string &out_license_code);

    // 暂不需要
    virtual bool update(std::string &error) { return true; };

    virtual void print_ukey();

private:
    std::shared_ptr<DBus::LicenseManagerProxyWrapper> license_manager_proxy_;
    std::shared_ptr<DBus::LicenseObjectProxyWrapper> license_object_proxy_;
};

}  // namespace Kiran