/**
 * @file          /kylin-license/src/notify/kiran-notify.h
 * @brief         
 * @author        tangjie02 <tangjie02@kylinos.com.cn>
 * @copyright (c) 2020 KylinSec. All rights reserved. 
 */
#pragma once

#include <giomm.h>

#include "lib/dbus/license_helper_proxy_wrapper.h"

namespace Kiran
{
class KiranNotify
{
public:
    KiranNotify();
    virtual ~KiranNotify();

    static KiranNotify *get_instance() { return instance_; };

    static void global_init();

    static void global_deinit() { delete instance_; };

private:
    void init();

    bool timing_check_license();

private:
    static KiranNotify *instance_;

    // 定时检测句柄
    sigc::connection timer_;
    // 检测次数
    int check_count_;

    std::shared_ptr<DBus::LicenseHelperProxyWrapper> proxy_;
};
}  // namespace Kiran