/**
 * @FilePath      /kylin-license/lib/license-notify.h
 * @brief         
 * @author        tangjie02 <tangjie02@kylinos.com.cn>
 * @copyright (c) 2020 KylinSec. All rights reserved. 
 */
#pragma once

#include <gio/gio.h>
#include <libnotify/notify.h>

namespace Kiran
{
#define NOTIFY_INFO(message) LicenseNotify::get_instance()->info(message);

#define NOTIFY_WARN(message) LicenseNotify::get_instance()->warn(message);

#define NOTIFY_ERROR(message) LicenseNotify::get_instance()->error(message);

class LicenseNotify
{
public:
    LicenseNotify();
    virtual ~LicenseNotify();

    static LicenseNotify *get_instance();

    // 普通消息
    void info(const char *message);

    // 告警消息
    void warn(const char *message);

    // 错误消息
    void error(const char *message);

private:
    void notify_send(const char *msg, const char *icon);

private:
    static LicenseNotify *instance_;

    NotifyNotification *notify_;
};
}  // namespace Kiran