/**
 * @file          /kylin-license/src/notify/main.cpp
 * @brief         
 * @author        tangjie02 <tangjie02@kylinos.com.cn>
 * @copyright (c) 2020 KylinSec. All rights reserved. 
 */
#include <dbus-c++/glib-integration.h>
#include <giomm.h>
#include <glib/gi18n.h>
#include <locale.h>

#include "lib/base/base.h"
#include "src/notify/kiran-notify.h"

::DBus::Glib::BusDispatcher dispatcher;

int main(int argc, char** argv)
{
    setlocale(LC_ALL, "");
    bindtextdomain(GETTEXT_DOMAIN, LICENSE_LOCALEDIR);
    bind_textdomain_codeset(GETTEXT_DOMAIN, "UTF-8");
    textdomain(GETTEXT_DOMAIN);

    auto loop = Glib::MainLoop::create();

    klog_gtk3_init(std::string(), "kylinsec-session", "kylin-license", Glib::path_get_basename(argv[0]));
    Gio::init();

    try
    {
        ::DBus::default_dispatcher = &dispatcher;
        dispatcher.attach(NULL);
        Kiran::KiranNotify::global_init();
    }
    catch (const std::exception& e)
    {
        KLOG_WARNING("%s", e.what());
    }

    loop->run();

    return 0;
}
