/**
 * @file          /kylin-license/src/server/uv-glib.h
 * @brief         
 * @author        tangjie02 <tangjie02@kylinos.com.cn>
 * @copyright (c) 2020 KylinSec. All rights reserved. 
 */
#pragma once

#include <giomm.h>
#include <uv.h>
namespace Kiran
{
class UVGlib
{
public:
    UVGlib();
    virtual ~UVGlib();

    static UVGlib* get_instance() { return instance_; };

    static void global_init();

    static void global_deinit() { delete instance_; };

private:
    void init();
    static void prepare_cb(uv_prepare_t* handle);
    static void poll_cb(uv_poll_t* handle, int status, int events);
    static void check_cb(uv_check_t* handle);

private:
    static UVGlib* instance_;

    uv_prepare_t prepare_handle_;
    uv_check_t check_handle_;

    GMainContext* main_context_;
    gint max_priority_;
    GPollFD* fds_;
    gint allocated_nfds_;
    gint nfds_;
    uv_poll_t* poll_handles_;
};
}  // namespace Kiran